﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Windows.Input;
using FreshMVVMSFDataGrid.Model;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FreshMVVMSFDataGrid.ViewModel
{
    public class RotatorPage1ViewModel : TemplateViewModelBase
    {

        double _growth = 0;

        public string Name
        {
            get;
            set;
        }

        public string Description
        {
            get;
            set;
        }

        public int PageNumber
        {
            get;
            set;
        }

        public string BackgroundColor
        {
            get;
            set;
        }

        public int Total
        {
            get;
            set;
        }





        #region Property OverrideValueOnKeyFocus

        public double OverrideValueOnKeyFocus
        {
            get;
            set;
        }

        #endregion

        #region Property OverrideValueOnLostFocus

        public double OverrideValueOnLostFocus
        {
            get;
            set;
        }

        #endregion

        #region Property AdHocWithdrawalsOnKeyFocus

        public double OverrideValueOnKeyFocusAfterSave
        {
            get;
            set;
        }


        #endregion;

        #region Property AddAdHocWithdrawalItemOnKeyFocusCommand

        public ICommand AddAdHocWithdrawalItemOnKeyFocusCommand
        {
            get
            {
                return new Command((param) =>
                {

                    OverrideValueOnKeyFocusAfterSave = OverrideValueOnKeyFocus;

                    OverrideValueOnKeyFocus = 0;
                });
            }
        }

        #endregion;

        #region Property AdHocWithdrawalsOnLostFocus

        public double OverrideValueOnLostFocusAfterSave
        {
            get;
            set;
        }

        #endregion;

        #region Property AddAdHocWithdrawalItemOnLostFocusCommand

        public ICommand AddAdHocWithdrawalItemOnLostFocusCommand
        {
            get
            {
                return new Command((param) =>
                {
                    OverrideValueOnLostFocusAfterSave = OverrideValueOnLostFocus;

                    OverrideValueOnLostFocus = 0;
                });
            }
        }

        #endregion



        #region Property Option1CheckBoxIsChecked

        public bool Option1CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option2CheckBoxIsChecked

        public bool Option2CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option3CheckBoxIsChecked

        public bool Option3CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option4CheckBoxIsChecked

        public bool Option4CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option5CheckBoxIsChecked

        public bool Option5CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option6CheckBoxIsChecked

        public bool Option6CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option7CheckBoxIsChecked

        public bool Option7CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option8CheckBoxIsChecked

        public bool Option8CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option9CheckBoxIsChecked

        public bool Option9CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Option10CheckBoxIsChecked

        public bool Option10CheckBoxIsChecked
        {
            get;
            set;
        }

        #endregion

        #region Property Growth

        public double Growth
        {
            get;
            set;
        }

        #endregion

        public Command AddCommand
        {
            get
            {
                return new Command(async () =>
                {
                    Total++;
                });
            }
        }

        #region Property StateChangedCommand

        public Command StateChangedCommand
        {
            get
            {
                return new Command(async (stateChangedResult) =>
                {
                    if (stateChangedResult != null)
                    {
                        Dictionary<string, string> result = (Dictionary<string, string>)stateChangedResult;
                        string controlName = result["ControlName"];
                        string state = result["State"];

                        switch (controlName)
                        {
                            case "Option1CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.01;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.01;
                                    }

                                    break;
                                }
                            case "Option2CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.02;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.02;
                                    }

                                    break;
                                }
                            case "Option3CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.03;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.03;
                                    }

                                    break;
                                }
                            case "Option4CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.04;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.04;
                                    }

                                    break;
                                }
                            case "Option5CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.05;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.05;
                                    }

                                    break;
                                }
                            case "Option6CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.06;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.06;
                                    }

                                    break;
                                }
                            case "Option7CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.07;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.07;
                                    }

                                    break;
                                }
                            case "Option8CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.08;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.08;
                                    }

                                    break;
                                }
                            case "Option9CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.09;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.09;
                                    }

                                    break;
                                }
                            case "Option10CheckBox":
                                {
                                    if (state == CheckBoxState.Checked.ToString())
                                    {
                                        _growth = _growth + 0.10;
                                    }
                                    else if (state == CheckBoxState.Unchecked.ToString())
                                    {
                                        _growth = _growth - 0.10;
                                    }

                                    break;
                                }
                            default:
                                {
                                    _growth = 0;
                                    break;
                                }
                        }

                        Growth = _growth;
                    }
                });
            }
        }

        #endregion
        
        public Command InsertPageCommand
       {
           get
           {
               return new Command(async () =>
               {
                   MessagingCenter.Send(this, "InsertPageClicked");
               });
           }
       }

    }
}