﻿using System;
using System.Windows.Input;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FreshMVVMSFDataGrid.ViewModel
{
    public class RotatorPage2ViewModel : TemplateViewModelBase
    {
        public string Choice1
        {
            get;
            set;
        }

        public string Choice2
        {
            get;
            set;
        }

        public string Choice3
        {
            get;
            set;
        }

        public string Choice4
        {
            get;
            set;
        }

        public string BackgroundColor
        {
            get;
            set;
        }

        #region Property Date

        public DateTime Date
        {
            get;
            set;
        }

        #endregion

        #region Property DateSelectedCommand

        public ICommand DateSelectedCommand
        {
            get
            {
                return new Command((param) =>
                {
                    if (param is DateChangedEventArgs dateChangedEventArgs)
                    {
                        Date = (DateTime) dateChangedEventArgs.NewDate;
                    }
                });
            }
        }

        #endregion

        #region Property Today

        private string _today;

        public string Today
        {
            get
            {
                return DateTime.Today.Date.ToString("yyyy,MM,dd");
            }
            set
            {
                _today = value;
            }
        }

        #endregion

    }
}